import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.filter.*;

/** This plugin runs for ~10 seconds or until the user presses the Esc key or clicks on the image window. */
public class Escape_ implements PlugInFilter {
	ImagePlus imp;
	ImageWindow win;
	boolean done;
	int slice;
	long startTime,timePerSlice;

	public int setup(String arg, ImagePlus imp) {
		this.imp = imp;
		if (imp!=null) {
			win = imp.getWindow();
			win.running = true;
			timePerSlice = 10000L/imp.getStackSize();
			startTime = System.currentTimeMillis();
		}
		return DOES_ALL+DOES_STACKS;
	}

	public void run(ImageProcessor ip) {
		if (done)
			return;
		slice++;
		long sliceStartTime = System.currentTimeMillis();
		while (true) {
			long time = System.currentTimeMillis();
			long ellapsedTime = time-startTime;
			IJ.showStatus("seconds: "+(time-startTime)/1000 + " (press esc to abort)");
			if ((time-sliceStartTime)>=timePerSlice)
				break;
			if (!win.running)
				{IJ.beep(); done=true; break;}
		}
	}

}
